%Estimation of State Capacity Spillovers
%Acemoglu, Garcia-Jimeno, Robinson

%Thsis function cleans the data from observations with missing values 

function [Yg_clean S_clean C_clean X_clean R_clean Yv_clean A_clean Dd_clean Drr_clean Drv_clean DaneCodes_clean] = clean_missings(Yg, S, C, X, R, Yv, A, Dd, Drr, Drv, DaneCodes)

DATA = [Yg S C X R Yv];                                                                                                                         %Stack all matrices together

drop = any(isnan(DATA),2);                                                                                                                      %Produces vector with 1's in rows where there are missing values

DATA_clean = DATA(~drop,:);                                                                                                                     %Produces data matrix without rows with missing observations

Yg_clean = DATA_clean(:,1:size(Yg,2));                                                                                                          %Produces Yg vector without rows with missing observations

S_clean = DATA_clean(:,size(Yg,2)+1:size(Yg,2)+size(S,2));                                                                                      %Produces S vector without rows with missing observations

C_clean = DATA_clean(:,size(Yg,2)+size(S,2)+1:size(Yg,2)+size(S,2)+size(C,2));                                                                  %Produces C vector without rows with missing observations

X_clean = DATA_clean(:,size(Yg,2)+size(S,2)+size(C,2)+1:size(Yg,2)+size(S,2)+size(C,2)+size(X,2));                                              %Produces X vector without rows with missing observations

R_clean = DATA_clean(:,size(Yg,2)+size(S,2)+size(C,2)+size(X,2)+1:size(Yg,2)+size(S,2)+size(C,2)+size(X,2)+size(R,2));                          %Produces R matrix without rows with missing observations

Yv_clean = DATA_clean(:,size(Yg,2)+size(S,2)+size(C,2)+size(X,2)+size(R,2)+1:end);                                                              %Produces Yv matrix without rows with missing observations

A_clean0 = A(~drop,:)';                                                                                                                         %Drops rows of municipalities with missing observations
A_clean = (A_clean0(~drop,:))';                                                                                                                 %Drops columns of municipalities with missing observations

Dd_clean0 = Dd(~drop,:)';                                                                                                                       %Drops rows of municipalities with missing observations
Dd_clean = (Dd_clean0(~drop,:))';                                                                                                               %Drops columns of municipalities with missing observations

Drr_clean0 = Drr(~drop,:)';                                                                                                                     %Drops rows of municipalities with missing observations
Drr_clean = (Drr_clean0(~drop,:))';                                                                                                             %Drops columns of municipalities with missing observations

Drv_clean0 = Drv(~drop,:)';                                                                                                                     %Drops rows of municipalities with missing observations
Drv_clean = (Drv_clean0(~drop,:))';                                                                                                             %Drops columns of municipalities with missing observations

DaneCodes_clean = DaneCodes(~drop,:);                                                                                                           %Drops codes of municipalities with missing observations