% To be transformed as a function with adjacency matrix as input

clear all
close all
clc


%Open data file State_Capacity_Network_Work.mat
load State_Capacity_Network_Work.mat

A=Adj; % Adjacency matrix

n=size(A,1);


% 1) BETWENNESS CENTRALITY

Q(:,:,1)=A;

productofA=A*A;

Q(:,:,2)=(ones(n,n)-A).*(A*A-diag(diag(productofA)));                 %Matrix of Number of Paths to Neighbors of Neighbors who are not own Neighbors

A_2=ismember(Q(:,:,2),1:1:max(max(Q(:,:,2))));                        %Adjacency Matrix of neighbors of neighbors
A_2=+A_2;                                               % from logical to numeric

sumofA=A+A_2;

i=2;
stop=0;

while stop<1
    i=i+1;
    
    productofA=A*productofA;
    
    Q(:,:,i)=(ones(n,n)-sumofA).*((productofA)-diag(diag(productofA)));      %for i=3 it is the matrix of Number of Paths to Neighbors of Neighbors of Neighbors who are not own Neighbors or own Neighbors of Neighbors and so on for i>3
    
    A_new=ismember(Q(:,:,i),1:1:max(max(Q(:,:,i))));                         %for i=3 it is the Adjacency Matrix of neighbors of neighbors of neighbors and so on for i>3
    A_new=+A_new;                                                            % from logical to numeric
    sumofA=sumofA + A_new;
    
    % check whether we connected all the nodes
    aux=eye(n)+sum(Q,3);
    if min(min(aux))>0
        stop=1;         % if we connected all the nodes, then stop
    end
    
end

tot_number_geodesics=sum(Q,3);  % number of shortest paths (geodesics) between two nodes


ratio=zeros(n,1);

for node=1:n
    
    for j=1:n-1
        
        for m=j+1:n
            
            if (node == j) || (node==m)
                 %do nothing
            else
                
                [paths_j_node, steps_j_node]=max(Q(j,node,:));  % [number of shortest paths (geodesics) that connect j to node, number of steps to connect j to node]
                [paths_node_m, steps_node_m]=max(Q(node,m,:));  % [number of shortest paths (geodesics) that connect node to m, number of steps to connect node to m]
                [number_paths, index]=max(Q(j,m,:));            % [number of shortest paths (geodesics) that connect j to m, number of steps to connect j to m]
                
                steps=steps_j_node+steps_node_m;
                
                if steps < index+1                              % in case node lies on one of the shortest paths, then we calculate how important it is in connecting j and m
                    
                    paths_with_node=paths_j_node*paths_node_m;  % number of geodesics between j and m that a certain node lies on
                    
                    ratio(node)=paths_with_node/number_paths+ratio(node);   % relative importance of node in connecting j and m
                end
            end
        end
    end
end

denom=(n-1)*(n-2)/2;
betweness_centrality=ratio/denom;



% 2) KATZ PRESTIGE

% g_hat = A ./ repmat(max(sum(A,1),1),n,1);     % normalized adjacency matrix
%
% [aux1, aux2]=eig(g_hat);
%
% Katz_prestige=aux1(:,2)*(-1);   % I get the eigenvector correspondent to the eigenvalue of 1 (which turns out to be the second one) and I multiply it for the scalar -1 since they are all negative numbers
%


% 3) KATZ PRESTIGE-2

% lambda=abs(max(max(aux2))); % highest eigenvalue
% a=1/lambda;

a=0.15;

Katzprestige_2=(eye(n)-a*A)\(a*A*ones(n,1));



% 4) BONACICH CENTRALITY

a=1;
b=0.15;

Bonacich=(eye(n)-b*A)\(a*A*ones(n,1));



% 5) GLOBAL CLUSTERING COEFFICIENT

% if two nodes are neighbors of i then there is an open tie

f = diag(A*A)-1;  % the diagonal of A*A gives the number of neighbors for each node

% For each node i, I calculate the number of open ties that have i as
% central node. If i has N neighbors then the number of open ties is
% (N-1)+(N-2)+(N-3)+...+1

c=f;

for i=1:n
    
    stop=f(i)-1;
    
    while stop>0
        
        c(i) = c(i)+stop;
        
        stop=stop-1;
    end
end

open = sum(c);

% if two nodes which are neighbors of i are also neighbors among themselves then we have a closed tie

closed = sum(sum(A.*(A*A))/2);  % A*A gives me the number of neigbors k that i and j have in common
                                % A.*() gets rid of the js that are not neighbors of i (and the diagonal)
                                % sum all these ties and divide by 2 because it is a symmetric matrix and so ties would be dounble counted

global_clustering = closed/open;


% 6) LOCAL CLUSTERING COEFFICIENT

k = diag(A*A);

denom = k.*(k-1)/2;  

numer = sum(A.*(A*A))/2;

local_clustering = numer' ./ denom; 

% Now I just need to take the average but local clustering is not defined
% when there is only one neighbor. So I need to eclude from the average
% those observations.

average_clustering = 0;

defined = zeros(n,1);

for i=1:n
    
    if denom(i)>0
        
        defined(i) = 1;
        
        average_clustering = average_clustering + local_clustering(i);
    end
end

average_clustering = average_clustering/sum(defined);



% APPENDIX: CHECK RESULT FOR CLUSTERING COEFFICIENT

% Weighted average should equalize global clustering coefficient. 
% This is just to make sure I have done the right calculations.

weights = k.*(k-1);
global_clust=0;
w=0;
for i=1:n
    if defined(i)==1
        global_clust = global_clust+weights(i)*local_clustering(i);
        w = w + weights(i);
    end
end
global_clust = global_clust/sum(w);

% Almost identical. The reason why they are not perfectly equal is the
% nodes with only one neighbor.



