function [ objective_fct_gmm ] = sys_gmm_objective_function( param_gmm, assum_f_delta, truncation_normal, nobin, biweight_kernel, order, num_out, ZOZ )
% This function computes the objective function that is going to be
% minimized in the GMM approach for the Best Response Equation

global k X p s pop hpop c r NE N N_2 X_d ndep d_bar e_bar n 

      theta = param_gmm(1);
      psi_1 = param_gmm(2);
      psi_2 = param_gmm(3:3+num_out-1);
      beta_out = param_gmm(3+num_out:3+num_out+(num_out*(k+1))-1)';
      zet_out = param_gmm(3+num_out+(num_out*(k+1)):3+num_out+(num_out*(k+1))+(num_out*ndep)-1)';
      phi = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep):3+num_out+(num_out*(k+1))+(num_out*ndep)+3-1)';
      beta_br = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1-1)';
      zet_br = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1)';
            
      %Parameters Identified to scale: Normalization delta1=1
           
if assum_f_delta==1                                            % if N(d) depends on delta (the neighbors matrices are assumed to depend on a parameter vector delta)      
      ddelta= param_gmm(end-1:end);  
      [ N_d, N_d_2, F_d] = neighbors_matrix( ddelta, order );  % call a function that generates the neighbors and neighbors of neighbors matrices which depend on delta
      NN=N_d;
      NN_2=N_d_2;
      Z_out=[NN*log(1+c) NN*r (NN*log(1+c)).^2 (NN*r).^2 (NN*log(1+c)).^3 (N*r).^3 (N*log(1+c)).^4 (N*r).^4 NN_2*log(1+c) NN_2*r (NN_2*log(1+c)).^2 (NN_2*r).^2 (NN_2*log(1+c)).^3 (NN_2*r).^3 (NN_2*log(1+c)).^4 (NN_2*r).^4 zscore(X) X_d hpop zscore(d_bar) zscore(e_bar)];
      Z_br=[NN*log(1+c) NN*r NN_2*log(1+c) NN_2*r log(1+c) r zscore(X) X_d log(hpop(:,1)) hpop(:,2) zscore(d_bar) zscore(e_bar)];
else
     NN=N;
     NN_2=N_2;
     
     Z_out=[NN*log(1+c) NN*r (NN*log(1+c)).^2 (NN*r).^2 (NN*log(1+c)).^3 (N*r).^3 (N*log(1+c)).^4 (N*r).^4 NN_2*log(1+c) NN_2*r (NN_2*log(1+c)).^2 (NN_2*r).^2 (NN_2*log(1+c)).^3 (NN_2*r).^3 (NN_2*log(1+c)).^4 (NN_2*r).^4 zscore(X) X_d hpop];
     Z_br=[NN*log(1+c) NN*r NN_2*log(1+c) NN_2*r log(1+c) r zscore(X) X_d log(hpop(:,1)) hpop(:,2)];
end


%GMM Minimization

    %Non parametric conditional expectation
    pphi=[phi; beta_br];
    xx=[log(1+c) r zscore(X) log(pop)];
    yy = s - ((psi_1/theta)*(NN*s)) - (X_d*zet_br);
    exp_cond_g= nonparametric_conditional( yy, xx, biweight_kernel, truncation_normal, pphi, nobin );  % It gives the conditional expectation of s+ppsi_gmm*N*s-X*bbeta_gmm conditional on c and lambda for each bin
    
    %Residuals:
    Qt = zeros(n,num_out);
    
    for i=1:num_out
        Qt(:,i) = zscore(p(:,i)) - (theta*(s.^2)) - (psi_2(i)*(NN*s)) - ([zscore(X) pop]*beta_out(((i-1)*k)+i:i*(k+1))) - (X_d*zet_out((1+((i*ndep)-ndep):i*ndep)));
    end
        
        q_br = s - ((psi_1/theta)*(NN*s)) - (X_d*zet_br) - exp_cond_g;
      
        Qt = [Qt  q_br];
        Q=Qt';
  
        
  ZZ = [Z_out Z_out Z_out Z_out Z_br]';      
        
  Q_gor = [repmat(Q(1,:),size(Z_out,2),1); repmat(Q(2,:),size(Z_out,2),1) ; repmat(Q(3,:),size(Z_out,2),1) ; repmat(Q(4,:),size(Z_out,2),1); repmat(Q(5,:),size(Z_br,2),1)];
        
   
  Zq_all = ZZ.*Q_gor;
  
  Zq = sum(Zq_all,2);
 
 objective_fct_gmm = (Zq'/((1/n)*ZOZ))*Zq;
 
 

end

